pragma Ada_95;
pragma Source_File_Name (zlib_adamain, Spec_File_Name => "b~zlib_ada.ads");
pragma Source_File_Name (zlib_adamain, Body_File_Name => "b~zlib_ada.adb");
with Ada.Exceptions;

package body zlib_adamain is
   pragma Warnings (Off);

   E16 : Short_Integer; pragma Import (Ada, E16, "system__soft_links_E");
   E26 : Short_Integer; pragma Import (Ada, E26, "system__exception_table_E");
   E51 : Short_Integer; pragma Import (Ada, E51, "ada__tags_E");
   E73 : Short_Integer; pragma Import (Ada, E73, "ada__streams_E");
   E60 : Short_Integer; pragma Import (Ada, E60, "interfaces__c_E");
   E62 : Short_Integer; pragma Import (Ada, E62, "interfaces__c__strings_E");
   E32 : Short_Integer; pragma Import (Ada, E32, "system__exceptions_E");
   E75 : Short_Integer; pragma Import (Ada, E75, "system__finalization_root_E");
   E72 : Short_Integer; pragma Import (Ada, E72, "ada__finalization_E");
   E70 : Short_Integer; pragma Import (Ada, E70, "system__storage_pools_E");
   E81 : Short_Integer; pragma Import (Ada, E81, "system__finalization_masters_E");
   E77 : Short_Integer; pragma Import (Ada, E77, "system__storage_pools__subpools_E");
   E89 : Short_Integer; pragma Import (Ada, E89, "system__pool_global_E");
   E20 : Short_Integer; pragma Import (Ada, E20, "system__secondary_stack_E");
   E02 : Short_Integer; pragma Import (Ada, E02, "zlib_E");
   E04 : Short_Integer; pragma Import (Ada, E04, "zlib__streams_E");
   E06 : Short_Integer; pragma Import (Ada, E06, "zlib__thin_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E02 := E02 - 1;
      E04 := E04 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "zlib__streams__finalize_spec");
      begin
         if E04 = 0 then
            F1;
         end if;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "zlib__finalize_spec");
      begin
         if E02 = 0 then
            F2;
         end if;
      end;
      E81 := E81 - 1;
      E77 := E77 - 1;
      E89 := E89 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "system__pool_global__finalize_spec");
      begin
         if E89 = 0 then
            F3;
         end if;
      end;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__storage_pools__subpools__finalize_spec");
      begin
         if E77 = 0 then
            F4;
         end if;
      end;
      declare
         procedure F5;
         pragma Import (Ada, F5, "system__finalization_masters__finalize_spec");
      begin
         if E81 = 0 then
            F5;
         end if;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure zlib_adafinal is
   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      finalize_library;
   end zlib_adafinal;

   type No_Param_Proc is access procedure;

   procedure zlib_adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      if E16 = 0 then
         System.Soft_Links'Elab_Spec;
      end if;
      if E26 = 0 then
         System.Exception_Table'Elab_Body;
      end if;
      E26 := E26 + 1;
      if E51 = 0 then
         Ada.Tags'Elab_Spec;
      end if;
      if E73 = 0 then
         Ada.Streams'Elab_Spec;
      end if;
      E73 := E73 + 1;
      if E60 = 0 then
         Interfaces.C'Elab_Spec;
      end if;
      if E62 = 0 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      if E32 = 0 then
         System.Exceptions'Elab_Spec;
      end if;
      E32 := E32 + 1;
      if E75 = 0 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E75 := E75 + 1;
      if E72 = 0 then
         Ada.Finalization'Elab_Spec;
      end if;
      E72 := E72 + 1;
      if E70 = 0 then
         System.Storage_Pools'Elab_Spec;
      end if;
      E70 := E70 + 1;
      if E81 = 0 then
         System.Finalization_Masters'Elab_Spec;
      end if;
      if E77 = 0 then
         System.Storage_Pools.Subpools'Elab_Spec;
      end if;
      if E89 = 0 then
         System.Pool_Global'Elab_Spec;
      end if;
      E89 := E89 + 1;
      E77 := E77 + 1;
      if E81 = 0 then
         System.Finalization_Masters'Elab_Body;
      end if;
      E81 := E81 + 1;
      E62 := E62 + 1;
      E60 := E60 + 1;
      if E51 = 0 then
         Ada.Tags'Elab_Body;
      end if;
      E51 := E51 + 1;
      if E16 = 0 then
         System.Soft_Links'Elab_Body;
      end if;
      E16 := E16 + 1;
      if E20 = 0 then
         System.Secondary_Stack'Elab_Body;
      end if;
      E20 := E20 + 1;
      if E02 = 0 then
         Zlib'Elab_Spec;
      end if;
      if E04 = 0 then
         Zlib.Streams'Elab_Spec;
      end if;
      E04 := E04 + 1;
      if E06 = 0 then
         Zlib.Thin'Elab_Body;
      end if;
      E06 := E06 + 1;
      E02 := E02 + 1;
   end zlib_adainit;

--  BEGIN Object file/option list
   --   ./zlib-streams.o
   --   ./zlib-thin.o
   --   ./zlib.o
   --   -L./
   --   -L/builddir/build/BUILD/zlib-ada/x86_64/
   --   -L/usr/share/gpr/
   --   -L/usr/lib/gcc/x86_64-redhat-linux/4.8.2/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end zlib_adamain;
